Before submitting a pull request be sure to check the code with [gometalinter](https://github.com/alecthomas/gometalinter).
This can save a considerable amount of time during code review.

Generally, try to follow this format when writing commit messages:
```
<name of the subsystem of bombardier if applicable or "all">: <short description of changes>

<A more elaborate description of the changes and maybe some explanations go here.>

<Fixes #<number of issue>, updates #<number of issue>, closes #<number of issue>. If applicable.>
```

Examples of such commit messages can be found in the commit log of this project or 
[in this section](https://golang.org/doc/contribute.html#commit_changes) of Go's Contribution Guidelines,
from which this format was adopted.

The pull request itself can contain a short description of changes made, questions or provide some other information, etc.
